//*****************************************************************************
//              \ /
// No Copyright (c) 2003
//              / \
// No rights reserved. This material contains published,
// non-copyrighted work, which includes non-confidential and
// non-proprietary information of Kurt Santel.
//
// Source: Square.h
//
// Description: Server-side Square class which describes the unit out of which
//              the Arena exists
//
//*****************************************************************************

#pragma once

class Square
{
public:
    typedef enum SquareType
    {
        Empty,
        Wall,
        Food,
        Life
    } SquareType;

    Square(SquareType type=Empty);
    ~Square(void);

    SquareType getType(void) { return( m_Type ); }

    void setNorth(Square * north) { m_North = north; }
    void setEast(Square * east)   { m_East = east; }
    void setSouth(Square * south) { m_South = south; }
    void setWest(Square * west)   { m_West = west; }

    Square * getNorth(void) { return( m_North ); }
    Square * getEast(void)  { return( m_East ); }
    Square * getSouth(void) { return( m_South ); }
    Square * getWest(void)  { return( m_West ); }

private:
    SquareType m_Type;

    // Neighbours, everybody needs good neighbours, with a little understanding, ...
    Square * m_North;
    Square * m_East;
    Square * m_South;
    Square * m_West;
};
